/* --- The following code comes from c:\lcc\lib\wizard\textmode.tpl. */
/* also copied from unprn.c, assembler listing to .asm converter */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#define INBUF 32			/* number of input chars */
char strbuf[INBUF+5];		/* Console I/O buffer	*/

void Usage(char *programName)
{
	fprintf(stderr,"%s <infilename> usage:\n",programName);
	fprintf(stderr,"changes Intel hex record to RCA load record.\n");
	fprintf(stderr,"outfilename is infilename+.rca.\n");
	fprintf(stderr,"asks before overwriting output file\n");
	fprintf(stderr,"%s -h prints this message.\n", programName);
	return;
}

/* returns the number of arguments up to two */
int HandleOptions(int argc,char *argv[])
{
	int i,options=0;

	for (i=1; i< argc;i++) {
		if (argv[i][0] == '/' || argv[i][0] == '-') {
			switch (argv[i][1]) {
				/* An argument -? means help is requested */
				case '?':
					Usage(argv[0]);
					return -1;
					break;
				case 'h':
				case 'H':
					if (!stricmp(argv[i]+1,"help")) {
						Usage(argv[0]);
						return -1;
						break;
					}

				default:
					fprintf(stderr,"unknown option %s\n",argv[i]);
					Usage(argv[0]);
					return -1;
					break;
			}
		}
		else { /* string is filename or number want exactly two */
			if (options==0 || options==1) options++;
			else {
				fprintf(stderr, "too many arguments\n");
				return -1;
			}
		}
	}
	if (options != 1) {
		fprintf(stderr, "too few or too many arguments\n");
		return -1;
	}
	return options; /* only returns 1 if successful */
}

int printbuf(char buffer[], FILE *outfile) {
	/* process Intel Hex buffer line to outfile line; but for now just echo line */
	/* input example is :0680E000B3F8F8A3E2D39F */
	/* output result would be !M80E0 B3 F8 F8 A3 E2 D3; */
	/* subsequent lines are 80F0 22 22 22 22; etc. */

	int buflen,cols;
	int goodcols, i, j;
	char thechar;
	int outerr;
	char bufout[512+80];
	int counter;

	buflen = strlen(buffer);
	bufout[0] = '\0'; i=0; /* empty IDIOT string */
	counter = 0;

	/* printf("strlen is %i, first chars are: ->%c%c%c<-\n", buflen, buffer[0], buffer[1], buffer[2]); */

	if (buffer[0] != ':') {
		printf ("input record has no : \n");	return 1;
	}

	if (buflen <= 12) { /* address record, skip */
		return 0; /* output empty string */
	}

	for (j=0;j<buflen;j++) { /* process hex record */

		thechar = buffer[j];

		if ( ((thechar >= '0') && (thechar <= '9')) || ((thechar >= 'A') && (thechar <= 'F')) ) {
		/* if (1) { */
			/* hex chars only */
			if ( (j>=3) && (j<=6) ) bufout[i++] = thechar; /* address */
			if (j==6) bufout[i++] = ' ';   /* blank after address */
			if (j>=9) { bufout[i++] = thechar; counter++; } /* data by two's */
			if (counter >= 2) { bufout[i++] = ' '; counter = 0; }
				 /* space every two hex data digits */

		}
	}
	bufout[i] = '\0'; /* terminate string just to be safe */


	/* line processed but some loose ends */
	/* first, the checksum byte and space at the end must be eliminated */
	/* second, counter won't be zero because it counts CR but not LF or something */
	/* so 'i' should be too long by four (space and checksum hex chars and crap) */
	/* and I have to add newline so fprintf() will produce CRLF */

	bufout[i-4] = ';'; bufout[i-3] = '\n'; bufout[i-2] = '\0';/* terminate line before space at checksum byte */
	/* printf("i=%i, counter=%i,-->%s<--",i, counter, bufout);  print to screen */

	outerr = fprintf(outfile, bufout, "%s");

	if (outerr == EOF) {
		printf ("write error or EOF on output file\n");	return -1;
	}
	return 0;
}

int main(int argc,char *argv[])
{
	int option; /* index of options in command line */
	FILE *infile;
	FILE *outfile;
	char filename[80]; /* look for this file */
	char outname[85];
	int fnamelen; /* length of filename */
	char buffer[512+80];

	int bufind, buflen; /*index into buffer and length of string */
	int i, j, founddot;
	int startit=1; /* flag start of output */
	char Mcmd[5]; /* IDIOT command to start  */
	int namepos=0; /*location of filename in imagefile*/
	int cols, goodcols; /* number of left columns to delete, correct cols with tabs=8 */
	int overwrite; /* true 1 or false 0 to overwrite output file*/

	Mcmd[0] = '!'; Mcmd[1]='M'; Mcmd[2]= '\0'; /* IDIOT command to start  */

	if (argc == 1) {
		/* If no arguments we call the Usage routine and exit */
		Usage(argv[0]);
		return 1;
	}
	/* handle the program options */

	option = HandleOptions(argc,argv);
	/* returns -1 on error, 0 if help request or index to first filename*/
	if (option < 1) return -1; /* error */
	/*otherwise see HandleOption for syntax */
	/* printf("option 1 is filename %s\n", argv[1]); */

	/* process filename to find */
	fnamelen = strlen(argv[1]);
	if (fnamelen < 80) strcpy(filename, argv[1]); else {
		fprintf(stderr,"filename too long  %s\n", argv[1]);
		return -1;
	} /* else filetofindname is filename to look for AND output file */
	printf("input filename is *%s*\n", filename);

	/* create filename.rca for output, remove any other extension */
	founddot = 0;
	for (i=0;i<fnamelen;i++) {
		outname[i]=filename[i];
		if (outname[i]=='.') {
			founddot = 1;
			strcpy(outname+i+1, "rca\0");
			break;
		}
	}
	if (founddot==0) strcpy(outname+fnamelen, ".rca\n");
	printf("Output filename is *%s*\n",outname);


	/* open input  file for read */
	infile = fopen(filename,"r");
	if (infile == 0) {
		fprintf(stderr,"input file %s not found\n", filename);
		return -1;
	}

	/* printf("main: past openfile input file\n"); */


	/* open output file for read to see if exists */
	overwrite = 1;
	outfile = fopen(outname,"r");
	if (outfile != 0) { /* it exists */
		//fprintf(stderr,"output file %s exists, I won't overwrite.\n", outname);
		/* get yes or no input, set overwrite 1 for yes 0 for no */
		printf("Destination file %s exists. Overwrite? Y/N ", outname);
		strbuf[0]=INBUF; cgets(strbuf);
 		if ( (toupper(strbuf[2])) == 'N') return 0;
		overwrite = 1;

		/* close output file either way */
		if (fclose (outfile)!= 0) {
			fprintf(stderr,"output file opened for read %s not closed\n", outname);
			return -1;
		}
	} /* else output file does not exist, we will open it below */

	/* if no overwrite close files and exit*/
	if (overwrite == 0) {
		fprintf(stderr,"no overwrite, close and exit\n");
		fclose (infile);
		return -1;
	}

	/* if yes to overwrite, or new file, open for write and go on*/
	outfile = fopen(outname,"w");
	if (outfile == 0) {
		fprintf(stderr,"output file %s not found\n", outname);
		return -1;
		}

	/* printf("main: past openfile output file\n"); */

	/* read line by line, process, print line out */

	namepos = 0; buffer[0]=0;
	while (1) {
		fgets(buffer, 512, infile);
		if (buffer == NULL) {
			fprintf(stderr,"input file read error\n");
			namepos = -1;
			break;
		}
		if (feof(infile)) {
			printf("\nEOF after %i lines\n",namepos);
			break;
		}
		if (startit) { /* first line has !M command */
			fprintf(outfile, Mcmd, "%s");
			startit = 0;
		}
		if (buffer[0] == ':') { /* process Intel record only */
			if (printbuf(buffer,outfile) != 0) break;
		}
		namepos = namepos + 1;
		/* printf("."); /*show a trail*/
	}

	/* close files */
	if (fclose (infile)!=0) {
		fprintf(stderr,"input file %s not closed\n", argv[option]);
		return -1;
	}

	if (fclose (outfile)!=0) {
		fprintf(stderr,"output file %s not closed\n", outname);
		return -1;
	}
	/* printf("main: past closefile input & output file\n"); */
	return 0;
}
